<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: SR_DevolucionFacturacion.xml */
/* Generado: 2021-07-04 00:45:36 */

/* Mantenimiento de los registros de la tabla SR_DevolucionFacturacion */
abstract class BaseSR_DevolucionFacturacionDP extends SR_DevolucionFacturacionBV
{
    /* Constructor ( Establece los valores desde un objeto SR_DevolucionFacturacionBN ) */
    public function __construct( SR_DevolucionFacturacionBN $o_SR_DevolucionFacturacionBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_SR_DevolucionFacturacionBN ) )
        {
            $this->setByBN( $o_SR_DevolucionFacturacionBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto SR_DevolucionFacturacionBN */
    public function setByBN( SR_DevolucionFacturacionBN $o_SR_DevolucionFacturacionBN )
    {
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getDevolFactId() ) )
        {
            $this->setDevolFactId( $o_SR_DevolucionFacturacionBN->getDevolFactId() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_SR_DevolucionFacturacionBN->getIdCompania() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_SR_DevolucionFacturacionBN->getIdSucursal() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getIdProyecto() ) )
        {
            $this->setIdProyecto( $o_SR_DevolucionFacturacionBN->getIdProyecto() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getIdPersona() ) )
        {
            $this->setIdPersona( $o_SR_DevolucionFacturacionBN->getIdPersona() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getGrupoId() ) )
        {
            $this->setGrupoId( $o_SR_DevolucionFacturacionBN->getGrupoId() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getTipoEstado() ) )
        {
            $this->setTipoEstado( $o_SR_DevolucionFacturacionBN->getTipoEstado() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getEstadoDesc() ) )
        {
            $this->setEstadoDesc( $o_SR_DevolucionFacturacionBN->getEstadoDesc() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getIdItem() ) )
        {
            $this->setIdItem( $o_SR_DevolucionFacturacionBN->getIdItem() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getDescripcionItem() ) )
        {
            $this->setDescripcionItem( $o_SR_DevolucionFacturacionBN->getDescripcionItem() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getFechaCorte() ) )
        {
            $this->setFechaCorte( $o_SR_DevolucionFacturacionBN->getFechaCorte() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getSubTotal() ) )
        {
            $this->setSubTotal( $o_SR_DevolucionFacturacionBN->getSubTotal() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getMontoIGV() ) )
        {
            $this->setMontoIGV( $o_SR_DevolucionFacturacionBN->getMontoIGV() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getMontoTotal() ) )
        {
            $this->setMontoTotal( $o_SR_DevolucionFacturacionBN->getMontoTotal() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getEstado() ) )
        {
            $this->setEstado( $o_SR_DevolucionFacturacionBN->getEstado() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getIdTipoDocumento() ) )
        {
            $this->setIdTipoDocumento( $o_SR_DevolucionFacturacionBN->getIdTipoDocumento() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getNumeroDocumento() ) )
        {
            $this->setNumeroDocumento( $o_SR_DevolucionFacturacionBN->getNumeroDocumento() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_SR_DevolucionFacturacionBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_SR_DevolucionFacturacionBN->getFechaCreacion() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_SR_DevolucionFacturacionBN->getUsuarioModificacion() );
        }
        if ( !is_null( $o_SR_DevolucionFacturacionBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_SR_DevolucionFacturacionBN->getFechaModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_SR_DevolucionFacturacionFN = new SR_DevolucionFacturacionFN();
        $o_SR_DevolucionFacturacionBN = $o_SR_DevolucionFacturacionFN->selectByPk( $this->getDevolFactId() );
        if ( is_null( $o_SR_DevolucionFacturacionBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO SR_DevolucionFacturacion ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getDevolFactId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DevolFactId";
                $s_SQLQuery2 .= $s_Separator."".$this->getDevolFactId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSucursal";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdProyecto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdProyecto";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdProyecto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdPersona() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdPersona";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdPersona()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getGrupoId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."GrupoId";
                $s_SQLQuery2 .= $s_Separator."'".$this->getGrupoId()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TipoEstado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTipoEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstadoDesc() ) )
            {
                $s_SQLQuery1 .= $s_Separator."EstadoDesc";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstadoDesc()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItem";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcionItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DescripcionItem";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcionItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCorte() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCorte";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCorte()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSubTotal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."SubTotal";
                $s_SQLQuery2 .= $s_Separator."".$this->getSubTotal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoIGV() ) )
            {
                $s_SQLQuery1 .= $s_Separator."MontoIGV";
                $s_SQLQuery2 .= $s_Separator."".$this->getMontoIGV()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoTotal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."MontoTotal";
                $s_SQLQuery2 .= $s_Separator."".$this->getMontoTotal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTipoDocumento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTipoDocumento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdTipoDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroDocumento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NumeroDocumento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNumeroDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE SR_DevolucionFacturacion SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSucursal = ".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdProyecto() ) )
            {
                $s_SQLQuery .= $s_Separator."IdProyecto = ".$this->getIdProyecto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdPersona() ) )
            {
                $s_SQLQuery .= $s_Separator."IdPersona = ".$this->getIdPersona()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getGrupoId() ) )
            {
                $s_SQLQuery .= $s_Separator."GrupoId = '".$this->getGrupoId()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."TipoEstado = '".$this->getTipoEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstadoDesc() ) )
            {
                $s_SQLQuery .= $s_Separator."EstadoDesc = '".$this->getEstadoDesc()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery .= $s_Separator."IdItem = '".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcionItem() ) )
            {
                $s_SQLQuery .= $s_Separator."DescripcionItem = '".$this->getDescripcionItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCorte() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCorte = '".$this->getFechaCorte()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSubTotal() ) )
            {
                $s_SQLQuery .= $s_Separator."SubTotal = ".$this->getSubTotal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoIGV() ) )
            {
                $s_SQLQuery .= $s_Separator."MontoIGV = ".$this->getMontoIGV()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoTotal() ) )
            {
                $s_SQLQuery .= $s_Separator."MontoTotal = ".$this->getMontoTotal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTipoDocumento() ) )
            {
                $s_SQLQuery .= $s_Separator."IdTipoDocumento = '".$this->getIdTipoDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroDocumento() ) )
            {
                $s_SQLQuery .= $s_Separator."NumeroDocumento = '".$this->getNumeroDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  DevolFactId = ".$this->getDevolFactId().";";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM SR_DevolucionFacturacion WHERE  DevolFactId = ".$this->getDevolFactId().";";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>